<?php
/**
 * Настройки модуля
 *
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.4
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2014 OOO «Диафан» (http://diafan.ru)
 */

if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

class Ubrr_admin_config extends Frame_admin
{
    public $config;

    public function __construct(&$diafan)
    {
        $this->config = array(
            "name" => 'УБРиР',
            "params" => array(
                'ubrr_client_id' => 'Идентификатор магазина',
                'ubrr_certificate_pass' => 'Пароль сертификата',
                'ubrr_test' => array('name' => 'Тестовый режим', 'type' => 'checkbox'),
            )
        );

        parent::__construct($diafan);
    }

    /**
     * Подготавливает конфигурацию модуля
     * @return void
     */
    public function prepare_config()
    {
        $select = array();
        $select[''] = $this->diafan->_('Все');

        foreach ($this->diafan->all_modules as $row) {
            if ($row["site_page"] && $row["name"] == $row["module_name"] || $row["name"] == "site") {
                $select[$row['module_name']] = $row['title'];
            }
        }
        $this->diafan->variable("module_name", 'select', $select);
    }


    /*
    public $variables = array ( //поля в базе данных для редактирования
        'config' => array (
            'nastr' => array(
                'type' => 'numtext',
                'name' => 'Количество элементов на странице',
                'help' => 'Количество одновременно выводимых элементов в списке.',
            ),
        )
    );
*/
    /*

    public $config = array(
        'config', // файл настроек модуля
    );
*/
}