<?php
/**
 * Редактирование статей
 *
 * @package    Diafan.CMS
 * @author     diafan.ru
 * @version    5.4
 * @license    http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2014 OOO «Диафан» (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Ubrr_admin_orders
 */
class Ubrr_admin_orders extends Frame_admin
{
    public $result;
    /**
     * @var string таблица в базе данных
     */
    public $table = 'ubrr_twpg_orders';

    /**
     * @var array настройки модуля
     */
    public $config = array(
        'order', // сортируется
    );

    /**
     * @var array списки из таблицы
     */
    public $select = array(
        'user_id' => array(
            'id',
            'diafan_order_id',
            'twpg_order_id',
            'twpg_session_id'
        ),
    );

    /**
     * Подготавливает конфигурацию модуля
     * @return void
     */
    public function prepare_config()
    {
        if (!empty($_GET['user'])) {
            $this->diafan->where = "";
        }
    }

    /**
     * Выводит контент модуля
     *
     * @return void
     */
    public function show()
    {
        // данные будем кэшировать
        $cache_meta = array(
            "name" => "list", // метка кэша
            "page" => $this->diafan->_route->page > 1 ? $this->diafan->_route->page : 1,
        );

        // если данных нет в кэше занесем их
        if (!$this->result = $this->diafan->_cache->get($cache_meta, 'ubrr_twpg_orders')) {
            $this->result = array();

            $sql = "SELECT * FROM {ubrr_twpg_orders} ORDER BY twpg_order_id DESC";
            ////navigation//
            $this->diafan->_paginator->nen = DB::query_result($sql);
            $this->result["paginator"] = $this->diafan->_paginator->get();
            ////navigation///

            $orders = DB::query_range_fetch_all($sql,
                $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);

            $this->result['orders'] = $orders;

            //сохранение кэша
            $this->diafan->_cache->save($this->result, $cache_meta, 'ubrr_twpg_orders');
        }

        $this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $this->result["paginator"]);

        //$this->result['view'] = 'show';

        echo $this->diafan->_tpl->get('show', 'ubrr', $this->result);
    }
}