<?php
/**
 * Формирует данные для формы платежной системы Robokassa
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    6.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2016 OOO «Диафан» (http://www.diafan.ru/)
 */

if (!defined('DIAFAN')) {
    $path = __FILE__;
    $i = 0;
    while (!file_exists($path . '/includes/404.php')) {
        if ($i == 10) exit;
        $i++;
        $path = dirname($path);
    }
    include $path . '/includes/404.php';
}

class Payment_ubrr_model extends Diafan
{
    /**
     * Формирует данные для формы платежной системы "УБРиР"
     *
     * @param array $params настройки платежной системы
     * @param array $pay данные о платеже
     * @return void
     */
    public function get($params, $pay)
    {
        $ubrrModuleDir = $_SERVER['DOCUMENT_ROOT'] . '/modules/ubrr/';
        include_once $ubrrModuleDir . 'classes/UBRIR_Diafan.php';

        $cmsModule = new UBRIR\Diafan();
        if (empty($params["ubrr_test"])) {
            $cmsModule->setNormalWorkMode();
        }

        $protocol = isset($_SERVER["HTTPS"]) ? 'https' : 'http';
        $host = $_SERVER['SERVER_NAME'];
        $callbackURL = $protocol . '://' . $host . '/payment/get/ubrr/callback';

        //Подготавливаем почву для оплаты
        $payId = $pay["id"];
        $orderId = UBRIR\Diafan::GetOrderIdByPayId($payId);

        $cmsModule->ServerConnectionConfig($params['ubrr_client_id'], $params['ubrr_certificate_pass']);
        $response = $cmsModule->SetupAndPrepareToPay($orderId, $pay["summ"], $callbackURL);

        if ($response->isSuccess()) {
            $TWPG_OrderId = $response->GetTWPG_OrderId();
            $SessionId = $response->GetSessionId();

            UBRIR\Diafan::SaveTWPGOrder($payId, $orderId, $TWPG_OrderId, $SessionId);

            //Уводим пользователя платить
            $PaymentURL = $response->GetPaymentUrl($TWPG_OrderId, $SessionId);
            $this->diafan->redirect($PaymentURL);
        } else {
            //Не удалось подготовиться как следует
        }
        exit;
    }
}