<?php
/**
 * Обработка данных, полученных от системы Robokassa
 *
 * @package    DIAFAN.CMS
 * @author     diafan.ru
 * @version    6.0
 * @license    http://www.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2016 OOO «Диафан» (http://www.diafan.ru/)
 */

//После установки этот файл лежит в /modules/payment/backend/ubrr
//Чтобы сюда попасть путь будет: http://site.ru/payment/get/ubrr и  в $rewriteRule прилетит payment/get/ubrr, и отброситься

if (!defined('DIAFAN')) {
    $path = __FILE__;
    $i = 0;
    while (!file_exists($path . '/includes/404.php')) {
        if ($i == 10) exit;
        $i++;
        $path = dirname($path);
    }
    include $path . '/includes/404.php';
}

$rewriteRule = $_REQUEST["rewrite"];
$rewriteRule = str_replace('payment/get/ubrr/', '', $rewriteRule);

$ubrrModuleDir = $_SERVER['DOCUMENT_ROOT'] . '/modules/ubrr/';
include_once $ubrrModuleDir . 'classes/UBRIR_Diafan.php';

$diafanModule = new UBRIR\Diafan();
$diafanModule->ConnectDiafanCore($this->diafan);

switch ($rewriteRule) {
    case 'callback': {
        $requestDataContainer = $diafanModule->HandleCallback();

        if ($requestDataContainer->isSuccess()) {
            $orderStatus = $requestDataContainer->getFieldValue('OrderStatus');

            $TWPG_OrderID = $requestDataContainer->getFieldValue('OrderId');
            //Получить номер локального заказа по банковскому
            $dbResult = UBRIR\Diafan::GetTWPGDataByUBRIROrderID($TWPG_OrderID);
            if ($dbResult === false) {
                $diafanModule->ShowError('Не найден заказ с платежным идентификатором = ' . $TWPG_OrderID);
                die;
            }

            $OrderId = $dbResult['order_id'];
            $payId = $dbResult['pay_id'];
            $SessionId = $dbResult['twpg_session_id'];

            $diafanOrderInfo = $this->diafan->_payment->check_pay($payId, 'ubrr');

            $resultData = new UBRIR\ResultViewer();
            $resultData
                ->SetPaymentTime($requestDataContainer->getFieldValue('date'))
                ->SetShopOrderId($OrderId)
                ->SetTWPG_OrderId($TWPG_OrderID)
                ->SetCardPAN($requestDataContainer->getFieldValue('PAN'))
                ->SetCardOwner($requestDataContainer->getFieldValue('Name'))
                ->SetPaymentAmount($requestDataContainer->getFieldValue('PurchaseAmountScr'));

            switch ($orderStatus) {
                case \UBRIR\TypeEnums::OrderStatus_APPROVED: {
                    $shopId = $diafanOrderInfo['params']['ubrr_client_id'];
                    $certificatePassword = $diafanOrderInfo['params']['ubrr_certificate_pass'];
                    if (empty($diafanOrderInfo['params']["ubrr_test"])) {
                        $diafanModule->setNormalWorkMode();
                    }
                    $diafanModule->ServerConnectionConfig($shopId, $certificatePassword);

                    $checkOrderStatusResponse = $diafanModule->SetupAndCheckOrderStatus($TWPG_OrderID, $SessionId);

                    if ($checkOrderStatusResponse->isSuccess()) {
                        $this->diafan->_payment->success($diafanOrderInfo, 'pay');

                        $successMessage = $requestDataContainer->getFieldValue('ResponseDescription');
                        $payModuleName = $diafanOrderInfo['module_name'];
                        $message = $requestDataContainer->getFieldValue('ResponseDescription');

                        $diafanModule->ShowPaymentSuccess($message, $resultData, $payModuleName);
                    } else {
                        $bankResponseDescription = $checkOrderStatusResponse->getFieldValue('ResponseDescription');

                        $resultData->AddExtraMessage($bankResponseDescription, 'Сообщение');
                    }
                }
                    break;
                case \UBRIR\TypeEnums::OrderStatus_CANCELED: {
                    $resultData->SetMessageBaseOnResponse($requestDataContainer);

                    $diafanModule->ShowError('', $resultData);
                }
                    break;
                case \UBRIR\TypeEnums::OrderStatus_DECLINED: {
                    $resultData->SetMessageBaseOnResponse($requestDataContainer);

                    $diafanModule->ShowError('', $resultData); //Платеж отклонен
                }
                    break;
                default: {
                    $diafanModule->ShowError('Неверный код ответа');
                }
                    break;
            }
        } else {
            $diafanModule->ShowError('Неверный формат ответа');
        }
    }
        break;
    case 'test_success': {
        $resultData = new UBRIR\ResultViewer();
        $resultData
            ->SetPaymentTime('01.02.2017 в 17:12')
            ->SetShopOrderId(1)
            ->SetTWPG_OrderId(5037)
            ->SetCardPAN('5106&nbsp;21**&nbsp;****&nbsp;9412')
            ->SetCardOwner('IVANOV PETR')
            ->SetPaymentAmount(2000);

        $diafanModule->ShowPaymentSuccess('Оплачен', $resultData);
    }
        break;
    case 'test_failure': {
        include_once('classes/UBRIR_OpenCart.php');

        $resultData = new UBRIR\ResultViewer();
        $resultData
            ->SetPaymentTime('01.02.2017 в 17:12')
            ->SetShopOrderId(1)
            ->SetTWPG_OrderId(5037)
            ->SetCardPAN('5106&nbsp;21**&nbsp;****&nbsp;9412')
            ->SetCardOwner('IVANOV PETR')
            ->SetPaymentAmount(2000);

        $resultData->AddExtraMessage('Тут могут быть расшифровки ошибок');

        $diafanModule->ShowError('Ошибка проверки оплаты заказа №' . 5037, $resultData);
    }
        break;

    default: {
        Custom::inc('includes/404.php');
    }
        break;
}
